import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

/**
 * Class BaseConverter
 *      Applet or application to convert a number
 *      from a base to another. The base must be
 *      between 2 and 36, inclusive.
 * 
 * @author  am
 * @version oct 2003
 */

public class BaseConverter extends JApplet {
    private JTextField base1Field ;
    private JTextField base2Field ;
    private JTextField number1Field ;
    private JLabel base1Label ;
    private JLabel base2Label ;    
    private JLabel number1Label ;    
    private JLabel number2Label ;
    private JLabel number2Value ;
    private JButton convertButton ;
    
    /** Constructor */
    public BaseConverter() {
    }  

	/**
	 * Called by the browser or applet viewer to inform this Applet that it
	 * has been loaded into the system. 
	 */
    public void init()
    {
        setContentPane(makeContentPane());
    }

    /**
     * Called by the applet or the application to construct the converter panel
     */
    public Container makeContentPane() {       
        // Create the container and define the layout
        JPanel converterPanel = new JPanel();
        converterPanel.setLayout(new GridLayout(3,   // number of rows
                                                4)); // number of columns

        // Create widgets
        base1Label = new JLabel("Base1  : ", SwingConstants.RIGHT);
        base1Field = new JTextField(3);
        base2Label = new JLabel("Base2  : ", SwingConstants.RIGHT);
        base2Field = new JTextField(3);
        number1Label = new JLabel("Value1 : ", SwingConstants.RIGHT);
        number1Field = new JTextField(8);
        number2Label = new JLabel("Value2 : ", SwingConstants.RIGHT);
        number2Value = new JLabel("");
        number2Value.setBorder(BorderFactory.createMatteBorder(1,1,2,2,Color.BLACK));
        convertButton = new JButton("Convert ... ");

        // Listen to events from Convert button
        convertButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                number2Value.setText(convert(number1Field.getText(), 
                                             base1Field.getText(),
                                             base2Field.getText() ) );
                } } 
            ) ;
        
        // Add widgets to container
        converterPanel.add(base1Label);
        converterPanel.add(base1Field);
        converterPanel.add(number1Label);
        converterPanel.add(number1Field);
        converterPanel.add(base2Label);
        converterPanel.add(base2Field);
        converterPanel.add(number2Label);
        converterPanel.add(number2Value);
        converterPanel.add(new JLabel("")); // for aligning the button
        converterPanel.add(new JLabel("")); // for aligning the button
        converterPanel.add(new JLabel("")); // for aligning the button
        converterPanel.add(convertButton);

        // Define background and borders
        converterPanel.setBackground(new Color(255, 255, 204));
        converterPanel.setBorder(BorderFactory.createMatteBorder(1,1,2,2,Color.BLACK));
        
        return converterPanel ;
    }
    
    /**
     * Convert number from base1 to base2
     * 
     * @param   number is given in base1
     * @param   base1 and base2 must be in [2, 36]
     * @return  number converted in base2
     */
    private String convert(String number, String base1, String base2) {
        // For test only
        return number + ":" + base1 + ":" + base2 ;
    }
          
    /**
     * The main application
     */
    public static void main(String[] args) {
        JFrame frame = new JFrame("Base converter");
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        
        BaseConverter baseConverter = new BaseConverter();
        frame.setContentPane(baseConverter.makeContentPane());
        frame.pack();
        frame.setVisible(true);
    }
        
}
