/**
 * Class Set - Set of integers within [0, nmax]
 */

public class Set
{
    private boolean[] set ;
    private int capacity ;	// = nmax
    private int cardinal ;	// number of elements
    
    public Set(int nmax)
    {
        set = new boolean[nmax+1] ; // +1 for having indice = element
        capacity = nmax ;
        cardinal = 0 ;
        for(int i=0; i<=capacity; i++) set[i]=false;
    }
    
    public int capacity() {
        return capacity ;
    }

    public int cardinal() {
        return cardinal ;
    }

    public boolean isElement(int n) {
        return (n>=0) && (n<=capacity) && set[n];
    }
    
    public void add(int n) {
        if (n>=0 && n<=capacity && !set[n]) {
            set[n]=true;
            cardinal++;
        }
    }

    public void addExtended(int n) {
        if (n<=capacity) {
            add(n);
        } else {
            boolean[] newset = new boolean[n+1] ;
            for(int i=0; i<=capacity; i++) newset[i] = set[i] ;
		for(int i=capacity+1; i<n; i++)  newset[i] = false; 
            newset[n]=true;
            set = newset ;
            capacity = n ;
            cardinal++ ;
        }
    }

    public void complement() {
        for(int i=0; i<=capacity; i++) set[i] = !set[i];
        cardinal = capacity - cardinal ;
    }
    
    public Set inter(Set e) {
        int dim = Math.min(capacity, e.capacity()) ;
        Set s = new Set(dim);
        for(int i=0; i<=dim; i++) {
            if (set[i] && e.isElement(i))  s.add(i) ;
        }
        return s ;
    }
    
} // end class Set
